#include <SDL.h>
#include <SDL_image.h>

int SDL_main(int,char**)
{
	//inicializace SDL - pouze video
	SDL_Init(SDL_INIT_VIDEO);
	IMG_Init(IMG_INIT_PNG);
	//vytvoen okna
	SDL_Window* MainWindow = SDL_CreateWindow("Vykresleni obrazku", //jmno okna
												SDL_WINDOWPOS_CENTERED, //okno bude vytvoeno ve stedu obrazovky
												SDL_WINDOWPOS_CENTERED,
												800, 600, NULL); //ka, vka a flagy okna (ty nepotebujeme)


	//vytvoen rendereru
	SDL_Renderer* renderer = SDL_CreateRenderer(MainWindow,-1,NULL);
	//naten obrzk
	SDL_Surface* SurfaceWithPicture = SDL_LoadBMP("Pictures/healer_f.bmp");
	SDL_Surface* SurfaceWithBackground = IMG_Load("Pictures/GreenBlackBG_0.png");
	//nastaven barvy, kter bude prhledn
	Uint32 WhiteColor = SDL_MapRGB(SurfaceWithPicture->format, 255, 255, 255);
	SDL_SetColorKey(SurfaceWithPicture, SDL_ENABLE, WhiteColor);
	//zjitn rozmr postavy
	int CharacterHeight = SurfaceWithPicture->h / 4;
	int CharacterWidth = SurfaceWithPicture->w / 3;
	//vytvoen obdelnka, na kter se bude vykreslovat na obrazovku
	SDL_Rect* TargetRectangle = new SDL_Rect;					
	TargetRectangle->x = TargetRectangle->y = 0;				
	TargetRectangle->w = TargetRectangle->h = CharacterHeight * 5;
	//obdelnk, ve kterm je nae postavave na zdrojovm obrzku
	SDL_Rect* CharacterSourceRect = new SDL_Rect;
	CharacterSourceRect->x = 1 * CharacterWidth;
	CharacterSourceRect->y = 2 * CharacterHeight;
	CharacterSourceRect->w = CharacterWidth;
	CharacterSourceRect->h = CharacterHeight;
	//vytvoen SDL_Surface, kter se pot zmn na SDL_Texture
	SDL_Surface* FinalSurface=SDL_CreateRGBSurface(NULL,								//flagy - nepotebujeme
		                                             CharacterHeight,CharacterHeight,   //rozmry Surface
													 32,								//barevn hloubka
													 0,0,0,0);							//masky barev - tak nepotebujeme
	//Vytvoen obdelnku, na kter se bude malovat tak, aby byla postava uprosted
	SDL_Rect* CharacterTargetRect = new SDL_Rect;
	CharacterTargetRect->h = CharacterHeight;
	CharacterTargetRect->w = CharacterWidth;
	CharacterTargetRect->y = 0;
	CharacterTargetRect->x = (FinalSurface->w - CharacterWidth) / 2;
	//pekreslen - nejprve pozad, potom postava
	SDL_BlitScaled(SurfaceWithBackground, NULL, FinalSurface, NULL);
	SDL_BlitSurface(SurfaceWithPicture,CharacterSourceRect,FinalSurface,CharacterTargetRect);
	//vytvoen SDL_Texture z SDL_Surface
	SDL_Texture* TextureWithCharacterAndBackground = SDL_CreateTextureFromSurface(renderer,FinalSurface);
	//Uvolnn prostedk
	SDL_FreeSurface(SurfaceWithPicture);
	SDL_FreeSurface(SurfaceWithBackground);
	SDL_FreeSurface(FinalSurface);
	delete CharacterSourceRect;
	delete CharacterTargetRect;


	
	bool End = false;						//promnn, kter d hlavn smyku
	SDL_Event* event=new SDL_Event;			//struktura, kter uchovv udlosti
	while (!End)							//zatek hlavn smyky
	{
		while (SDL_PollEvent(event))		//naten udlosti z fronty
		{
			if (event->type == SDL_QUIT)		//manipulace s udlost
				End = true;					//ukonen aplikace
			else if (event->type == SDL_KEYDOWN)		//reagovn na stisk klvesy
			{
				switch (event->key.keysym.sym)
				{
				case SDLK_RIGHT:					//ipka v pravo -> upraven x-ov pozice obdelnku
					TargetRectangle->x += 5; break;
				case SDLK_LEFT:						//ipka v levo -> upraven x-ov pozice obdelnku
					TargetRectangle->x -= 5; break;
				case SDLK_UP:						//ipka nahoru -> upraven y-ov pozice obdelnku
					TargetRectangle->y -= 5; break;
				case SDLK_DOWN:						//ipka dol -> upraven y-ov pozice obdelnku
					TargetRectangle->y += 5; break;
				}
			}
		}

		SDL_SetRenderDrawColor(renderer, 0, 0, 255, 255);		//nastaven barvy, kterou se bude vykreslovat pozad
		SDL_RenderClear(renderer);								//vykreslen pozad

		//vykreslen postavy
		SDL_RenderCopy(renderer,TextureWithCharacterAndBackground,NULL,TargetRectangle); 

		SDL_RenderPresent(renderer);
		


	}

	//nen poteba mazat jednotliv objekty, po ukonen programu voln msto automaticky promae OS

	IMG_Quit();								//ukonen SDL_Image
	SDL_Quit();								//Ukonen SDL
	return 0;
}